The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Fir Class Reference

STK general finite impulse response filter class. More...

`#include <Fir.h>`

Inheritance diagram for stk::Fir:

List of all members.

## Public Member Functions
| Fir (void)
| Default constructor creates a zero-order pass-through "filter".
| Fir (std::vector< StkFloat > &coefficients)
| Overloaded constructor which takes filter coefficients.
| ~Fir (void)
| Class destructor.
void | setCoefficients (std::vector< StkFloat > &coefficients, bool clearState=false)
| Set filter coefficients.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK general finite impulse response filter class.

This class provides a generic digital filter structure that can be used to implement FIR filters. For filters with feedback terms, the Iir class should be used.

In particular, this class implements the standard difference equation:

y[n] = b[0]*x[n] + ... + b[nb]*x[n-nb]

The gain parameter is applied at the filter input and does not affect the coefficient values. The default gain value is 1.0. This structure results in one extra multiply per computed sample, but allows easy control of the overall filter gain.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::Fir::Fir | ( | std::vector< StkFloat > & | coefficients | ) |

Overloaded constructor which takes filter coefficients.

An StkError can be thrown if the coefficient vector size is zero.

## Member Function Documentation

void stk::Fir::setCoefficients | ( | std::vector< StkFloat > & | coefficients,
|  | bool | clearState = `false` |
| ) |  |  |

Set filter coefficients.

An StkError can be thrown if the coefficient vector size is zero. The internal state of the filter is not cleared unless the clearState flag is `true`.

StkFrames & stk::Fir::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00101 {
    00102 #if defined(_STK_DEBUG_)
    00103   if ( channel >= frames.channels() ) {
    00104     oStream_ << "Fir::tick(): channel and StkFrames arguments are incompatible!";
    00105     handleError( StkError::FUNCTION_ARGUMENT );
    00106   }
    00107 #endif
    00108
    00109   StkFloat *samples = &frames[channel];
    00110   unsigned int i, hop = frames.channels();
    00111   for ( unsigned int j=0; j<frames.frames(); j++, samples += hop ) {
    00112     inputs_[0] = gain_ * *samples;
    00113     *samples = 0.0;
    00114
    00115     for ( i=b_.size()-1; i>0; i-- ) {
    00116       *samples += b_[i] * inputs_[i];
    00117       inputs_[i] = inputs_[i-1];
    00118     }
    00119     *samples += b_[0] * inputs_[0];
    00120   }
    00121
    00122   lastFrame_[0] = *(samples-hop);
    00123   return frames;
    00124 }

StkFrames & stk::Fir::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00127 {
    00128 #if defined(_STK_DEBUG_)
    00129   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00130     oStream_ << "Fir::tick(): channel and StkFrames arguments are incompatible!";
    00131     handleError( StkError::FUNCTION_ARGUMENT );
    00132   }
    00133 #endif
    00134
    00135   StkFloat *iSamples = &iFrames[iChannel];
    00136   StkFloat *oSamples = &oFrames[oChannel];
    00137   unsigned int i, iHop = iFrames.channels(), oHop = oFrames.channels();
    00138   for ( unsigned int j=0; j<iFrames.frames(); j++, iSamples += iHop, oSamples += oHop ) {
    00139     inputs_[0] = gain_ * *iSamples;
    00140     *oSamples = 0.0;
    00141
    00142     for ( i=b_.size()-1; i>0; i-- ) {
    00143       *oSamples += b_[i] * inputs_[i];
    00144       inputs_[i] = inputs_[i-1];
    00145     }
    00146     *oSamples += b_[0] * inputs_[0];
    00147   }
    00148
    00149   lastFrame_[0] = *(oSamples-oHop);
    00150   return iFrames;
    00151 }

The documentation for this class was generated from the following file:

- Fir.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.